//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "SegIndi.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TSegIndi *)
{
        new TSegIndi(NULL);
}
//---------------------------------------------------------------------------
__fastcall TSegIndi::TSegIndi(TComponent* Owner)
        : TGraphicControl(Owner)
{
 FSymbols=new TStringList;
 Width=25;
 Height=41;
 FOnPenColor=clBtnText;
 FOnBrushColor=clBtnText;
 FOffPenColor=clGrayText;
 FOffBrushColor=clGrayText;
 FOnSegments.Clear();
 FOnSegments=FOnSegments<<segA<<segB<<segC<<segD<<segE<<segF;
 FExSegments.Clear();
 FExSegments=FExSegments<<segA<<segB<<segC<<segD<<segE<<segF<<segG<<segH;
 FSymbols->Clear();
 FSymbols->Add("ABCDEF");//0
 FSymbols->Add("BC");   //1
 FSymbols->Add("ABGED"); //2
 FSymbols->Add("ABGCD"); //3
 FSymbols->Add("FGBC");//4
 FSymbols->Add("AFGCD");//5
 FSymbols->Add("AFEDCG");//6
 FSymbols->Add("ABC");//7
 FSymbols->Add("ABCDEFG");//8
 FSymbols->Add("GFABCD");//9
 FSymbolIndex=0;
 FLineWidth=3;
 FSymbols->OnChange=OnSymbolsChange;
}
//---------------------------------------------------------------------------
__fastcall TSegIndi::~TSegIndi()
{
 delete FSymbols;
}
//----------------------------------------------------------------
namespace Segindi
{
        void __fastcall PACKAGE Register()
        {
                 TComponentClass classes[1] = {__classid(TSegIndi)};
                 RegisterComponents("Samples", classes, 0);
        }
}
//---------------------------------------------------------------------------
void __fastcall TSegIndi::SetOnPenColor(TColor Col)
{
 FOnPenColor=Col;
 Invalidate();
}
//-------------------------------------------------
void __fastcall TSegIndi::SetOffPenColor(TColor Col)
{
 FOffPenColor=Col;
 Invalidate();
}
//---------------------------------------------------
void __fastcall TSegIndi::SetOnBrushColor(TColor Col)
{
 FOnBrushColor=Col;
 Invalidate();
}
//-------------------------------------------------
void __fastcall TSegIndi::SetOffBrushColor(TColor Col)
{
 FOffBrushColor=Col;
 Invalidate();
}
//--------------------------------------------------------------
void __fastcall TSegIndi::SetOnSegments(TIndiSegments Segs)
{
 //if(Segs==FOnSegments)return;
 FOnSegments=Segs;
 if(OnChange)
  OnChange(this);
 Invalidate();
}
//-----------------------------------------------------
void __fastcall TSegIndi::SetExSegments(TIndiSegments Segs)
{
 FExSegments=Segs;
 Invalidate();
}
//---------------------------------------------------------
void __fastcall TSegIndi::SetSymbols(TStringList* Strings)
{
 FSymbols->Assign(Strings);
 //SetSymbolIndex(FSymbolIndex);
}
//---------------------------------------------------------
void __fastcall TSegIndi::OnSymbolsChange(TObject* Sender)
{
 SetSymbolIndex(FSymbolIndex);
}
//----------------------------------------------------------
void __fastcall TSegIndi::SetSymbolIndex(int Index)
{
 //if(FSymbolIndex==Index)return;
 TIndiSegments NewSegs;
 FSymbolIndex=Index;
 if(FSymbolIndex>=0&&FSymbolIndex<FSymbols->Count)
 {
  NewSegs.Clear();
  for(char i='A';i<'H';i++)
  {
   if(FSymbols->Strings[FSymbolIndex].UpperCase().Pos((AnsiString)i)>0)
    NewSegs=NewSegs<<(TIndiSegment)(i-'A');
  }
  if(NewSegs==FOnSegments)return;
  FOnSegments=NewSegs;
  if(OnChange)
   OnChange(this);
  Invalidate();
 }
}
//----------------------------------------------------------
void __fastcall TSegIndi::SetLineWidth(int Width)
{
 if(Width!=FLineWidth)
 {
  if(Width>0)FLineWidth=Width;
  Invalidate();
 }
}
//-----------------------------------------------------------
void __fastcall TSegIndi::Paint()
{
 int Half=LineWidth/2+LineWidth%2;
 int VerH=(Height-LineWidth)/2-Half-2;
 int HorL=Width-LineWidth-2*Half-2;
 if(!ExSegments.Contains(segA))
 {
  Canvas->Pen->Style=psClear;
  Canvas->Brush->Style=bsClear;
 }
 else
 {
  Canvas->Pen->Style=psSolid;
  Canvas->Brush->Style=bsSolid;
  if(OnSegments.Contains(segA))
  {
   Canvas->Pen->Color=FOnPenColor;
   Canvas->Brush->Color=FOnBrushColor;
  }
  else
  {
   Canvas->Pen->Color=FOffPenColor;
   Canvas->Brush->Color=FOffBrushColor;
  }
 }
 DrawHorLine(Half+1,Half,HorL);//A
 if(!ExSegments.Contains(segB))
 {
  Canvas->Pen->Style=psClear;
  Canvas->Brush->Style=bsClear;
 }
 else
 {
  Canvas->Pen->Style=psSolid;
  Canvas->Brush->Style=bsSolid;
  if(OnSegments.Contains(segB))
  {
   Canvas->Pen->Color=FOnPenColor;
   Canvas->Brush->Color=FOnBrushColor;
  }
  else
  {
   Canvas->Pen->Color=FOffPenColor;
   Canvas->Brush->Color=FOffBrushColor;
  }
 }
 DrawVerLine(Width-LineWidth-Half,Half+1,VerH);//B
 if(!ExSegments.Contains(segC))
 {
  Canvas->Pen->Style=psClear;
  Canvas->Brush->Style=bsClear;
 }
 else
 {
  Canvas->Pen->Style=psSolid;
  Canvas->Brush->Style=bsSolid;
  if(OnSegments.Contains(segC))
  {
   Canvas->Pen->Color=FOnPenColor;
   Canvas->Brush->Color=FOnBrushColor;
  }
  else
  {
   Canvas->Pen->Color=FOffPenColor;
   Canvas->Brush->Color=FOffBrushColor;
  }
 }
 DrawVerLine(Width-LineWidth-Half,(Height-LineWidth)/2+1,VerH);//C
 if(!ExSegments.Contains(segD))
 {
  Canvas->Pen->Style=psClear;
  Canvas->Brush->Style=bsClear;
 }
 else
 {
  Canvas->Pen->Style=psSolid;
  Canvas->Brush->Style=bsSolid;
  if(OnSegments.Contains(segD))
  {
   Canvas->Pen->Color=FOnPenColor;
   Canvas->Brush->Color=FOnBrushColor;
  }
  else
  {
   Canvas->Pen->Color=FOffPenColor;
   Canvas->Brush->Color=FOffBrushColor;
  }
 }
 DrawHorLine(Half+1,Height-LineWidth-Half,HorL);//D
 if(!ExSegments.Contains(segE))
 {
  Canvas->Pen->Style=psClear;
  Canvas->Brush->Style=bsClear;
 }
 else
 {
  Canvas->Pen->Style=psSolid;
  Canvas->Brush->Style=bsSolid;
  if(OnSegments.Contains(segE))
  {
   Canvas->Pen->Color=FOnPenColor;
   Canvas->Brush->Color=FOnBrushColor;
  }
  else
  {
   Canvas->Pen->Color=FOffPenColor;
   Canvas->Brush->Color=FOffBrushColor;
  }
 }
 DrawVerLine(Half,(Height-LineWidth)/2+1,VerH);    //E
 if(!ExSegments.Contains(segF))
 {
  Canvas->Pen->Style=psClear;
  Canvas->Brush->Style=bsClear;
 }
 else
 {
  Canvas->Pen->Style=psSolid;
  Canvas->Brush->Style=bsSolid;
  if(OnSegments.Contains(segF))
  {
   Canvas->Pen->Color=FOnPenColor;
   Canvas->Brush->Color=FOnBrushColor;
  }
  else
  {
   Canvas->Pen->Color=FOffPenColor;
   Canvas->Brush->Color=FOffBrushColor;
  }
 }
 DrawVerLine(Half,Half+1,VerH);    //F
 if(!ExSegments.Contains(segG))
 {
  Canvas->Pen->Style=psClear;
  Canvas->Brush->Style=bsClear;
 }
 else
 {
  Canvas->Pen->Style=psSolid;
  Canvas->Brush->Style=bsSolid;
  if(OnSegments.Contains(segG))
  {
   Canvas->Pen->Color=FOnPenColor;
   Canvas->Brush->Color=FOnBrushColor;
  }
  else
  {
   Canvas->Pen->Color=FOffPenColor;
   Canvas->Brush->Color=FOffBrushColor;
  }
 }
 DrawHorLine(Half+1,(Height-LineWidth)/2,HorL);//G
 if(!ExSegments.Contains(segH))
 {
  Canvas->Pen->Style=psClear;
  Canvas->Brush->Style=bsClear;
 }
 else
 {
  Canvas->Pen->Style=psSolid;
  Canvas->Brush->Style=bsSolid;
  if(OnSegments.Contains(segH))
  {
   Canvas->Pen->Color=FOnPenColor;
   Canvas->Brush->Color=FOnBrushColor;
  }
  else
  {
   Canvas->Pen->Color=FOffPenColor;
   Canvas->Brush->Color=FOffBrushColor;
  }
 }
 DrawPoint(Width-Half,Height-2*LineWidth,2*LineWidth-Half);//H
}
//---------------------------------------------------------
void __fastcall TSegIndi::DrawVerLine(int x,int y,int h)
{
 int Half=LineWidth/2;
 TPoint points[6];
 points[0] = Point(x,y);
 points[1] = Point(x+Half,y+Half);
 points[2] = Point(x+Half,y+h-Half);
 points[3] = Point(x,y+h);
 points[4] = Point(x-Half,y+h-Half);
 points[5] = Point(x-Half,y+Half);
 Canvas->Polygon(points,5);
}
//-----------------------------------------------------------
void __fastcall TSegIndi::DrawHorLine(int x,int y,int l)
{
 int Half=LineWidth/2;
 TPoint points[6];
 points[0] = Point(x,y);
 points[1] = Point(x+Half,y-Half);
 points[2] = Point(x+l-Half,y-Half);
 points[3] = Point(x+l,y);
 points[4] = Point(x+l-Half,y+Half);
 points[5] = Point(x+Half,y+Half);
 Canvas->Polygon(points,5);
}
//-----------------------------------------------------------
void __fastcall TSegIndi::DrawPoint(int x,int y,int h)
{
 int Half=LineWidth/2;
 TPoint points[5];
 points[0] = Point(x,y);
 points[1] = Point(x+Half,y+Half);
 points[2] = Point(x+Half,y+h-Half);
 points[3] = Point(x-Half,y+h+Half);
 points[4] = Point(x-Half,y+Half);
 Canvas->Polygon(points,4);
}
//-----------------------------------------------------------